(define-module (ordo facts user)
  #:use-module (rx irregex)
  #:use-module (srfi srfi-1)
  #:use-module (ordo connection)
  #:export (fact:id
            fact:pwent))

(define (parse-id-output s)
  (let ((data (reverse (irregex-fold (irregex '(seq (=> id integer) "(" (=> name (+ alphanumeric)) ")"))
                                     (lambda (_ m accum)
                                       (cons `((#:id . ,(string->number (irregex-match-substring m 'id)))
                                               (#:name . ,(irregex-match-substring m 'name)))
                                             accum))
                                     '()
                                     s))))
    `((#:user-id . ,(assoc-ref (first data) #:id))
      (#:user-name . ,(assoc-ref (first data) #:name))
      (#:group-id . ,(assoc-ref (second data) #:id))
      (#:group-name . ,(assoc-ref (second data) #:name))
      (#:groups . ,(drop data 2)))))

(define (fact:id conn)
  (run conn "id" #:check? #t #:return (compose parse-id-output car)))

(define (parse-passwd-entry s)
  (map cons
       '(#:user-name #:password #:user-id #:group-id #:gecos #:home-dir #:shell)
       (string-split s #\:)))

(define (fact:pwent conn user-name)
  (run conn "getent" "passwd" user-name
       #:check? #t #:return (compose parse-passwd-entry car)))
